<template>
  <ValidationObserver v-slot="{ handleSubmit }">
    <CForm
      v-loading="loading"
      class="group-form"
      @submit.prevent="handleSubmit(onSubmit)"
    >
      <CCard>
        <CCardBody>
          <div class="box-inner-form">
            <ValidationProvider v-slot="{ errors }" rules="required">
              <CInput
                v-model="model.name"
                type="text"
                label="Name"
                placeholder="Enter name"
                horizontal
              >
                <template #prepend-content>
                  <font-awesome-icon :icon="['fas', 'sitemap']" class="width-1x" />
                </template>
                <template #invalid-feedback>
                  <div class="d-block invalid-feedback">
                    {{ errors[0] }}
                  </div>
                </template>
              </CInput>
            </ValidationProvider>
            <ValidationProvider v-slot="{ errors }" rules="required">
              <CSelect
                v-model="model.zone"
                label="In zones"
                horizontal
                :options="OPTIONS"
                placeholder="Please select"
                :value.sync="model.zone"
              >
                <template #prepend-content>
                  <font-awesome-icon :icon="['fas', 'th']" class="width-1x" />
                </template>
                <template #invalid-feedback>
                  <div class="d-block invalid-feedback">
                    {{ errors[0] }}
                  </div>
                </template>
              </CSelect>
            </ValidationProvider>
            <CTextarea
              v-model="model.description"
              label="Description"
              placeholder="Description"
              horizontal
              rows="2"
            >
              <template #prepend-content>
                <font-awesome-icon :icon="['fas', 'bars']" class="width-1x" />
              </template>
            </CTextarea>
          </div>
        </CCardBody>

        <CCardFooter>
          <CButton
            type="submit"
            color="primary"
          >
            <font-awesome-icon :icon="['fas', 'save']" class="width-1x" />
            Save
          </CButton>

          <CButton
            color="secondary"
            @click="$emit('close')"
          >
            Cancel
          </CButton>
        </CCardFooter>
      </CCard>
    </CForm>
  </ValidationObserver>
</template>

<style lang="scss" scoped>
  .group-form {
    .card {
      border-top: 0;
      margin-bottom: 0;
    }
  }
</style>

<script>
import { get } from 'lodash'
import Group from '~/models/Group'
import createEditForm from '~/mixins/create-edit-form'

export default {
  mixins: [createEditForm],

  data () {
    return {
      model: new Group(),
      modelType: 'group',
      data: []
    }
  },

  computed: {
    /**
     * Return list zone item options
     *
     */
    OPTIONS () {
      const options = []
      this.data.forEach((item) => {
        const param = { value: item.id, label: item.name }
        options.push(param)
      })
      return options
    }
  },

  mounted () {
    this.prepareData()
  },

  methods: {
    /**
     * set user status
     * @param {Boolean} val
     * @param {Object} event
     */
    setStatus (val, event) {
      this.model.status = parseInt(event.target.value)
    },

    /**
     * Prepare data
     *
     */
    prepareData () {
      this.$dam.getZoneList()
        .then((res) => {
          this.data = res.data
        })
        .catch((err) => {
          const message = get(err, 'response.data.message', null)
          if (message) {
            this.$toast.error(message)
          } else {
            this.$toast.error(
              this.$text.error('FAILED_TO_DATA')
            )
          }
        })
    },

    /**
     * Dynamic set model
     * @param {Object} data
     */
    setModel (data) {
      this.model = new Group(data)
    }
  }
}
</script>
